<%@ Page Language="vb" Strict="True" %>

<script language="vb" runat="server">
    '*********************************************************************
    '*  DEMO VERSION NOTICE:
    '*  The demo version of this product contains a static barcode that may be
    '*  used for evaluation purposes only. The static barcode cannot be
    '*  changed because this would reveal the complete formula, which is only
    '*  available in the purchased version. The purchased version is provided 
    '*  with a money back satisfaction guarantee. If it is necessary to 
    '*  test dynamic barcodes with this product, the purchased version is required.
    '*  http://www.idautomation.com/barcode-components/ssrs-generator/
    '*********************************************************************
    Sub createBarcode()
        
        Dim i As Integer, height As Integer, width As Integer, lines As String(), lines2 As String(), count As Integer
        Dim k as Integer , xFactor as Integer, sTemp as String 
        
        xFactor = 3
        
        height = 23
        width = 23
	
        lines = New String() {}
        ReDim lines(height)
	
        lines(22) = "00000000000000000000000"
        lines(21) = "01111111000010011111110"
        lines(20) = "01000001001011010000010"
        lines(19) = "01011101001010010111010"
        lines(18) = "01011101010110010111010"
        lines(17) = "01011101010100010111010"
        lines(16) = "01000001000111010000010"
        lines(15) = "01111111010101011111110"
        lines(14) = "00000000011100000000000"
        lines(13) = "01110011101001000110000"
        lines(12) = "01111110000000010011010"
        lines(11) = "01110011100011100001100"
        lines(10) = "00000100001100101011100"
        lines(9) = "01000111011000000011100"
        lines(8) = "00000000011000100101000"
        lines(7) = "01111111010001000011100"
        lines(6) = "01000001011000100001110"
        lines(5) = "01011101001110010110000"
        lines(4) = "01011101000000010111100"
        lines(3) = "01011101000001010101110"
        lines(2) = "01000001010010100011000"
        lines(1) = "01111111011010010010100"
        lines(0) = "00000000000000000000000"

        
        lines2 = New String() {}
        ReDim lines2(height*xFactor)
        count = UBound(lines) - 1
        For i = 0 To count
          sTemp = widen(lines(i), xFactor)
          For k = 0 to xFactor - 1  
            lines2((i*xFactor) + k ) = tstr(sTemp)
          Next  
        Next

        height = xFactor * height  
        width = xFactor * width  
        writeBarcode(getHeader(width, height) & Join(lines2, ""))
    End Sub

    Function widen(ByVal code As String, ByVal XDim As Integer) As String
        If XDim = 1 Then
          widen = code
        Else
          widen = Replace( Replace( code, "0", Replace( Space(XDim), " ", "0") ) , "1", Replace(Space(XDim), " ", "1") )
        End If
    End Function    
    
    
    Dim tStrCache As System.Collections.Specialized.StringDictionary = New System.Collections.Specialized.StringDictionary()

    Function tstr(ByVal data As String) As String
        If tStrCache.ContainsKey(data) Then
            tstr = tStrCache.Item(data)
            Exit Function
        End If

        
        
        Dim tchar As Integer, total As String, tpos As Integer, i As Integer, j As Integer, x As Integer
        tchar = 0
        total = ""
        tpos = 8
        For i = 1 To Len(data)
            tpos = tpos - 1
            If Mid(data, i, 1) <> "0" Then tchar = CInt(tchar + 2 ^ tpos)
            If tpos = 0 Then
                total = total & Chr(tchar)
                tpos = 8
                tchar = 0
            End If
        Next
        If tpos <> 8 Then
            total = total & Chr(tchar)
        End If
        x = Len(total) Mod 4
        If x = 0 Then x = 4
        For i = x To 3
            total = total & Chr(0)
        Next

        tStrCache.Add(data, total)
        tstr = total
    End Function

    Function size(ByVal length As Double) As String
        length = CDbl(length)
        If length > 255 Then
            If length > 65535 Then length = 65535
            size = Chr(CInt(length Mod 256)) & Chr(CInt(Int(length / 256)))
        Else
            size = Chr(CInt(length)) & Chr(0)
        End If
    End Function

    Function getHeader(ByVal width As Integer, ByVal height As Integer) As String
        getHeader = Chr(66) & Chr(77) & size(62 + (width * height)) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(62) & Chr(0) & Chr(0) & Chr(0) & Chr(40) & Chr(0) & Chr(0) & Chr(0) & size(width) & Chr(0) & Chr(0) & size(height) & Chr(0) & Chr(0) & Chr(1) & Chr(0) & Chr(1) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(37) & Chr(14) & Chr(0) & Chr(0) & Chr(37) & Chr(14) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(255) & Chr(255) & Chr(255) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0)
    End Function

    Function stb(ByVal StringArg As String) As Byte()
        Dim I As Integer, B As System.Collections.Generic.List(Of Byte) = New System.Collections.Generic.List(Of Byte)
        For I = 1 To StringArg.Length()
            B.Add(CByte(Asc(Mid(StringArg, I, 1))))
        Next
	
        stb = B.ToArray
    End Function
	    
    Sub writeBarcode(ByVal data As String)
        Response.ContentType = "image/bmp"
        Response.BinaryWrite(stb(data))
    End Sub
    
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Call createBarcode()
    End Sub
    
</script>

